Subject: Re: Bug (ID 2H66N): Valid multi-part/mixed breaks pine

From: David L Miller <[email-masked]>
Date: Tue, 2 Sep 1997 14:39:05 -0700 (PDT)

On Sat, 19 Jul 1997, Robert de Bath wrote:

> From: Robert de Bath <[email-masked]>
> Date: Sat, 19 Jul 1997 07:46:21 +0100 (BST)
> Cc: Pine Discussion Forum <[email-masked]>
> Subject: Bug (ID 2H66N): Valid multi-part/mixed breaks pine
> Organization: Mayday Technology Ltd
> X-URL: http://www.cix.co.uk/~mayday
> X-Alternate-address: User rdebath on machine cix.co.uk
> X-Mailer: Pine 3.96 for Linux
> Message-ID: <36c204914624d95bc0269edf4d7fd231@uk>
> 
> 
> The problem is that the boundary= field in the header is unquoted.
> According to rfc2046 (line 1048) this is perfectly valid if the 
> characters in the boundary string all pass rfc822's rules.

My reading ot RFC 2046 is that the overall header has to conform to
RFC822's rules.  The overall grammar for the Content-Type header is
defined in RFC2045. 

> 
> From rfc822 the characters in a header atom can be any printable
> ascii except space, control characters and the specials: ()<>*,;:\".[]

See section 5.1 of RFC2045.  The prohibited characters in an unquoted
parameter value are SPACE, CTLs, and the tspecials:  ()<>@,;:\"/[]?=

> 
> The header of this messages has the boundary:  _=-742
> This passes these rules but pine 3.96 does not display the first part of
> the message and panics with an abort() if you attempt to view any other
> part.

We'll check to see that Pine 4.00 doesn't crash on this sort of
boundary, but it still won't parse the way it was intended.  Since no
valid boundary was found, Pine will assume that the rest of the
message is the preamble and should not be displayed.  

BTW, you can display the raw message by piping it to cat...

> 
> Machine: IBM PC running Linux 2.0.30 with GCC 2.7.2 and libc 5.4.7
> Pine Vs: 3.95q and 3.96
> Attached message is JUNK!!!
> 
> -- 
> Rob.                           (Robert de Bath <http://www.cix.co.uk/~mayday>)
> 

Thanks for the report!

-- 
David L. Miller <[email-masked]> | 640K ought to be enough for
Software Engineer, Pine Development Team | anybody. -- Bill Gates, in 1981
Box 354841, University of Washington     |
4545 15th Ave NE, Seattle WA 98105, USA  |
Phone: (206)685-6240  FAX: (206)685-4045 |